comment -Ŀ
                                                                
  
  
         
               print date and time              
          
  
   history:
    2002/01/05: initial version                   (245 bytes)
    2002/01/31: argh,  replaced a 9 instruction loop by 4 in-
                structions  for  printing the day,  as it was
                already being done below for printing all the
                other numbers;  also  fixed a  thinko,  at no
                cost in size                      (233 bytes)
    2002/01/31: Bonzini pointed out that it's 11th, not 11st,
                so I fixed that. I also remembered why I used
                that loop there, namely  to print '1' instead
                of '01' in the day.               (242 bytes)
  
-
.model tiny
; assumes:
; ax = 00xxh
; bp = 09xxh
        X       equ     80h
        Y       equ     80h
.386
.code
.startup
        mov     di, bp                  ; di = buffer at 09xxh
        mov     si, offset days - 1
        mov     al, 06                  ; CMOS addr 06: day of week
        call    putnthstr               ; print the prefix before 'day'
        mov     si, offset pmonths
        call    putstr                  ; print 'day '
        dec     si
        mov     al, 08h                 ; CMOS addr 08: month
        call    putnthstr               ; print month
        mov     al, 32
        stosb                           ; print ' '
        mov     al, 07h                 ; CMOS addr 07: day of month
        out     70h, al
        in      al, 71h
        aam     16
        dec     ah
        add     ax, 3130h
        jc      skip1
        mov     [di], ah
        inc     di
skip1:  stosb
        cmp     ah, 2Dh
        jpo     skip2
        cmp     al, 33h
skip2:  mov     ax, 'ht'
        ja      store
        mov     ax, 'dr'
        je      store
        mov     ax, 'dn'
        jpe     store
th:     mov     ax, 'ts'                ; print 'st', 'nd', 'rd', 'th'
store:  stosw                           ; as appropriate.
        mov     si, offset rest         ; and now print
@restl: lodsb                           ; ' YYYY, HH:MM:SS', 0D, 0A, '$'
        aam     Y
        sahf                            ; strip and test high bit
        jnc     sto                     ; if not set, simply print
        out     70h, al                 ; the character, else print
        in      al, 71h                 ; the number from the CMOS at the
        aam     16                      ; specified address
        add     ax, 3030h
        mov     [di],ah
        inc     di
sto:    stosb
        cmp     al, '$'
        jne     @restl
        mov     dx, bp                  ; finally, really print the string
        xchg    ax, bp                  ; (which we only put into a buffer)
        int     21h
        ret

putnthstr:
        out     70h, al                 ; get CMOS entry
        in      al, 71h
        xchg    ax, cx                  ; n -> cx
_nth_:  lodsb
        cmp     al,X
        ja      _nth_
        loop    _nth_                   ; skip n strings
putstr: lodsb
        aam     X
        stosb
        sahf
        jc      putstr                  ; put the n+1st or the given string
        ret

pmonths:db      'd'+X, 'a'+X, 'y'+X, ' '
months: db      'J'+X, 'a'+X, 'n'+X, 'u'+X, 'a'+X, 'r'+X, 'y'
        db      'F'+X, 'e'+X, 'b'+X, 'r'+X, 'u'+X, 'a'+X, 'r'+X, 'y'
        db      'M'+X, 'a'+X, 'r'+X, 'c'+X, 'h'
        db      'A'+X, 'p'+X, 'r'+X, 'i'+X, 'l'
        db      'M'+X, 'a'+X, 'y'
        db      'J'+X, 'u'+X, 'n'+X, 'e'
        db      'J'+X, 'u'+X, 'l'+X, 'y'
        db      'A'+X, 'u'+X, 'g'+X, 'u'+X, 's'+X, 't'
        db      'S'+X, 'e'+X, 'p'+X, 't'+X, 'e'+X, 'm'+X, 'b'+X, 'e'+X, 'r'
        db      'O'+X, 'c'+X, 't'+X, 'o'+X, 'b'+X, 'e'+X, 'r'
        db      'N'+X, 'o'+X, 'v'+X, 'e'+X, 'm'+X, 'b'+X, 'e'+X, 'r'
        db      'D'+X, 'e'+X, 'c'+X, 'e'+X, 'm'+X, 'b'+X, 'e'+X, 'r'

days:   db      'M'+X, 'o'+X, 'n'
        db      'T'+X, 'u'+X, 'e'+X, 's'
        db      'W'+X, 'e'+X, 'd'+X, 'n'+X, 'e'+X, 's'
        db      'T'+X, 'h'+X, 'u'+X, 'r'+X, 's'
        db      'F'+X, 'r'+X, 'i'
        db      'S'+X, 'a'+X, 't'+X, 'u'+X, 'r'
        db      'S'+X, 'u'+X, 'n'

rest:   db      ' ', 32h+Y, 09h+Y, ',', ' '
; 32h - CMOS addr for century, 09h - year
        db      04h+Y, ':', 02h+Y, ':', 00h+Y, 0Dh, 0Ah, '$'
; 04h - hour, 02h - minute, 00h - seconds

end

